#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct rat {
  long long p,q;
};

rat ctab[4][4];

#define MAX_TMPL 100000
    
struct axc {
  int n, ui;
  rat r;
  double apx;
} templates[MAX_TMPL];

int cmp_tmpl(const void *a, const void *b)
{
  axc *aa=(axc *)a;
  axc *bb=(axc *)b;
  return (int)(aa->apx-bb->apx);
}

int main()
{
  int n_test;
  for (int i=0; i<4; i++)
    for (int k=0; k<4; k++) { ctab[i][k].p=0, ctab[i][k].q=0; }
  for (int k=0; k<4; k++) { ctab[k][k].p=1; ctab[k][k].q=1; }

  scanf("%d\n", &n_test);
  for (int k=0; k<n_test; k++) {
    int n_conv, n_tmpl, n_test;
    
    char u1[3][16], u2[3][16];
    char *names[4];
    int ni=0;
    int conv[3];

    scanf("%d\n", &n_conv);
    fprintf(stderr, "%d conv\n", n_conv);
    for (int j=0; j<n_conv; j++) {
      int tmpi;
      char tmps[100];
      scanf("%d", &tmpi);
      scanf("%s", u1[j]);
      scanf("%s", tmps);
      scanf("%d", conv+j);
      scanf("%s\n", u2[j]);
      fprintf(stderr, "%d '%s' [%s] %d '%s'\n", tmpi, u1[j], tmps, conv[j], u2[j]);
      for (int i=0; i<ni; i++) if (strcmp(u1[j],names[i])==0) goto dont_add_1;
      names[ni++]=u1[j];
dont_add_1:
      for (int i=0; i<ni; i++) if (strcmp(u2[j],names[i])==0) goto dont_add_2;
      names[ni++]=u2[j];
dont_add_2:
      ;
    }
    fprintf(stderr, "---, %d names\n", ni);
    for (int i=0; i<ni; i++)
      fprintf(stderr, "  %s\n", names[i]);
    fprintf(stderr, "--\n");
    for (int i=0; i<n_conv; i++) {
      int j1, j2;
      for (j1=0; j1<ni; j1++) if (strcmp(names[j1], u1[i])==0) break;
      for (j2=0; j2<ni; j2++) if (strcmp(names[j2], u2[i])==0) break;
      fprintf(stderr, "%d => %d %d\n", i, j1, j2);
      ctab[j1][j2].p=conv[i];
      ctab[j1][j2].q=1;
      ctab[j2][j1].q=conv[i];
      ctab[j2][j1].p=1;
    }
    int tofix=0;
    for (int i=0; i<ni; i++) {
      for (int j=0; j<ni; j++) {
        fprintf(stderr, " %lld/%lld", ctab[i][j].p, ctab[i][j].q);
        if (ctab[i][j].q==0) tofix++;
      }
      fprintf(stderr, "\n");
    }
    fprintf(stderr, "tofix: %d\n", tofix);

    while (tofix) {
      for (int i=0; i<ni; i++)
        for (int j=0; j<ni; j++)
          if (ctab[i][j].q==0) {
            fprintf(stderr, "fix: %d %d\n", i,j);
            for (int ii=0; ii<ni; ii++) if (ii!=i) {
              if (ctab[ii][j].q!=0&&ctab[0][ii].q!=0) {
                fprintf(stderr, "found: %d\n", ii);
                ctab[i][j].p=ctab[ii][j].p*ctab[0][ii].p;
                ctab[i][j].q=ctab[ii][j].q*ctab[0][ii].q;
                ctab[j][i].q=ctab[ii][j].p*ctab[0][ii].p;
                ctab[j][i].p=ctab[ii][j].q*ctab[0][ii].q;
                tofix-=2;
                break;
              }
            }
          }
    }
    for (int i=0; i<ni; i++) {
      for (int j=0; j<ni; j++) {
        fprintf(stderr, " %lld/%lld", ctab[i][j].p, ctab[i][j].q);
        if (ctab[i][j].q==0) tofix++;
      }
      fprintf(stderr, "\n");
    }
    
    scanf("%d\n", &n_tmpl);
    fprintf(stderr, "%d templ\n", n_tmpl);
    for (int j=0; j<n_tmpl; j++) {
      int tmpi;
      char tmps[100];
      scanf("%d\n", &tmpi);
      scanf("%s\n", tmps);
      templates[j].n=tmpi;
      int l;
      for (l=0; l<ni; l++) if (strcmp(tmps, names[l])==0) { templates[j].ui=l; break; }
      templates[j].r.p=templates[j].n*ctab[l][0].p;
      templates[j].r.q=ctab[l][0].q;
      templates[j].apx=(double)templates[j].r.p/templates[j].r.q;
      fprintf(stderr, "%lld/%lld %lf\n", templates[j].r.p, templates[j].r.q, templates[j].apx);
    }
    qsort(templates, n_tmpl, sizeof(*templates), cmp_tmpl);
    for (int i=0; i<n_tmpl; i++) fprintf(stderr, "# %lf\n", templates[i].apx);

    scanf("%d\n", &n_test);
    fprintf(stderr, "%d tests\n", n_test);
    for (int j=0; j<n_test; j++) {
      int tmpi;
      char tmps[100];
      scanf("%d\n", &tmpi);
      scanf("%s\n", tmps);
      axc a, *b;

      int l;
      for (l=0; l<ni; l++) if (strcmp(tmps, names[l])==0) { templates[j].ui=l; break; }
      a.r.p=tmpi*ctab[j][0].p;
      a.r.q=tmpi*ctab[j][0].q;
      a.apx=(double)a.r.p/a.r.q;
      b=(axc *)bsearch(&a, templates, n_tmpl, sizeof(*templates), cmp_tmpl);
      if (b>templates&&(!(a.r.p==b->r.p)&&(a.r.q==b->r.q))) b--;
      printf("%d %s\n", b->n, names[b->ui]);
    }
  }
  return 0;
}
