#include <stdio.h>
#include <stdlib.h>

#define MAXP 500
#define X 0
#define Y 1

typedef int point[2];

int np;
point p1[MAXP], p2[MAXP];
int use1[MAXP], use2[MAXP];

struct xxx {
  int p1i, p2i;
  double d;
} con[MAXP*MAXP];

double dist(point a, point b)
{
  return ((double)a[0]-(double)b[0])*((double)a[0]-(double)b[0])+
         ((double)a[1]-(double)b[1])*((double)a[1]-(double)b[1]);
}

int comp(const void *a, const void *b)
{
  xxx *pa=(xxx *)a;
  xxx *pb=(xxx *)b;
  return (pb->d)-(pa->d)>0;
}

void solve()
{
  int r=0;
  for (int i=0; i<np; i++) {
    for (int j=0; j<np; j++) {
      con[r].p1i=i;
      con[r].p2i=j;
      con[r++].d=dist(p1[i], p2[j]);
    }
    use1[i]=use2[i]=np;
  }
  for (int k=0; k<np*np; k++)
    fprintf(stderr, "%lf %d %d\n", con[k].d, con[k].p1i, con[k].p2i);
  fprintf(stderr, "---\n");
  qsort(con, np*np, sizeof(xxx), comp);
  for (int k=0; k<np*np; k++)
    fprintf(stderr, "%lf %d %d\n", con[k].d, con[k].p1i, con[k].p2i);
  fprintf(stderr, "---\n");
  
  int k=0;
  
  while (1) {
    if (use1[con[k].p1i]==1||use2[con[k].p2i]==1) break;
    use1[con[k].p1i]--;
    use2[con[k].p2i]--;
    k++;
  }
  fprintf(stderr, "--> %d\n", (int)con[k].d);
}

int main()
{
  int n_set;
  scanf("%d\n", &n_set);
  for (int k=0; k<n_set; k++) {
    scanf("%d\n", &np);
    for (int l=0; l<np; l++) scanf("%d %d", &(p1[l][X]), &(p1[l][Y]));
    for (int l=0; l<np; l++) scanf("%d %d", &(p2[l][X]), &(p2[l][Y]));
    solve();
  }
  return 0;
}
