#include <cstdio>
#include <cstdlib>


typedef unsigned long uint32;
typedef long long int64;

struct Plane
{
  int64 A, B, C, D;
  
  double dist(double x, double y, double z)
  {
    return x*A + y*B + z*C + D;
  }
  
  int64 dist(int64 x, int64 y, int64 z)
  {
    return x*A + y*B + z*C + D;
  }
  
  void flip()
  {
    A = -A;
    B = -B;
    C = -C;
    D = -D;
    
    //puts("flipping plane");
  }
};

Plane *planes;

void solve()
{
  double centerX = 0;
  double centerY = 0;
  double centerZ = 0;

  uint32 faces = 0;
  scanf("%d", &faces);
  
  for (uint32 i = 0; i < faces; ++i)
  {
    uint32 verts = 0;
    scanf("%d", &verts);
    
    long Ix, Iy, Iz;
    scanf("%ld %ld %ld", &Ix, &Iy, &Iz);
    long Jx, Jy, Jz;
    scanf("%ld %ld %ld", &Jx, &Jy, &Jz);
    long Kx, Ky, Kz;
    scanf("%ld %ld %ld", &Kx, &Ky, &Kz);
   
    if (verts != 3) while(getchar() != '\n') {}
    
    int64 Ax = Jx - Ix;
    int64 Ay = Jy - Iy;
    int64 Az = Jz - Iz;
    
    int64 Bx = Kx - Ix;
    int64 By = Ky - Iy;
    int64 Bz = Kz - Iz;

    Plane &p = planes[i];

    int64 &Nx = p.A, &Ny = p.B, &Nz = p.C;
    
    Nx = Ay*Bz - Az*By;
    Ny = Ax*Bz - Az*Bx;
    Nz = Ax*By - Bx*Ay;
    
    p.D = Ix * Nx + Iy * Ny + Iz * Nz;
    p.D = -p.D;
    
    if (i < 4)
    {
      centerX += Ix * 2 + Jx + Kx;
      centerY += Iy * 2 + Jy + Ky;
      centerZ += Iz * 2 + Jz + Kz;
    }
  }
  
  centerX /= 16;
  centerY /= 16;
  centerZ /= 16;
  //printf("center: %lf %lf %lf\n", centerX, centerY, centerZ);
  
  for (uint32 i = 0; i < faces; ++i)
  {
    if (planes[i].dist(centerX, centerY, centerZ) < 0)
      planes[i].flip();
      
      
    //printf("plane: %lld %lld %lld %lld\n", planes[i].A, planes[i].B, planes[i].C, planes[i].D);
  }
  
  uint32 points = 0;
  scanf("%d", &points);
  
  for (uint32 i = 0; i < points; ++i)
  {
    long x, y, z;
    scanf("%ld %ld %ld", &x, &y, &z);
    
    bool ok = true;
    for (uint32 j = 0; j < faces; ++j)
    {
      //printf("plane: %lld %lld %lld %lld\n", planes[j].A, planes[j].B, planes[j].C, planes[j].D);

      double dist = planes[j].dist((int64)x, (int64)y, (int64)z);
      if (dist < 0)
      {
        ok = false;
        break;
      }
    }
    
    if (ok) puts("TAK");
    else puts("NIE");
  }
}

int main()
{
  uint32 tests = 0;
  scanf("%d", &tests);
  
  planes = new Plane[200000];
  
  for (uint32 i = 0; i < tests; ++i)
  {
    solve();
    printf("\n");
  }

  return 0;
}