#include <cstdio>
#include <vector>
using namespace std;
const long INFL = 0x7fffffff / 2 - 1;
const int MAXV = 50002;
typedef struct
{
  long v;
  long weight;
  long w;
  long t;
  long a;
  long l;
} edge;
typedef struct
{
  vector <long> degree;
  vector <vector<edge> > edges;
  long nedges;
  long nvertices;
} graph;
bool discovered [MAXV];
bool processed [MAXV];
long parent [MAXV];
void insert_edge (graph *g, long x, long y, bool directed, long w, long t, long a, long l)
{
   edge ae;
   
   vector <edge> av;
   while (x >= g->nvertices)
   {
     g->degree.push_back(0);
     g->edges.push_back(av);
     g->nvertices++;
   }
   g->degree[x]++;
   g->edges[x].push_back(ae);
   g->edges[x].back().v=y;
   g->edges[x].back().weight=w;
   g->edges[x].back().t=t;
   g->edges[x].back().a=a;
   g->edges[x].back().l=l;
   
   if (directed==false)
     insert_edge(g,y,x,true,w, t, a, l);
   else
     g->nedges++;
}

void read_graph (graph *g, bool directed)
{
  long i;
  long m;
  long x, y;
  long w;
  long t;
  long a;
  long l;
  
  vector <edge> av;
  g->edges.clear();
  g->degree.clear();
  g->nedges=0;
  g->nvertices=0;
  g->degree.push_back(0);
  g->edges.push_back(av);
  scanf ("%ld %ld", &g->nvertices, &m);
  for (i = 1; i <= g->nvertices; i++)
  {
    g->degree.push_back (0);
    g->edges.push_back (av);
  }
  for (i = 1; i <= m; i++)
  {
    scanf ("%ld %ld %ld %ld %ld %ld", &x, &y, &w, &t, &a, &l);
    insert_edge (g,x,y,directed,w, t, a, l);
    
  }
}

void print_graph (graph *g)
{
  long i, j;
  for (i=1; i<=g->nvertices; i++)
  {
    printf ("%ld: ", i);
    for (j=0;j<g->degree[i]; j++)
      printf (" %ld->%ld", g->edges[i][j].v, g->edges[i][j].weight);
    printf ("\n");
  }
}

long distan[MAXV];

void dijkstra (graph *g, long start)
{
  long dod;
  long i;
  bool intree[MAXV];
  long v;
  long w;
  long weight;
  long dist;
  
  for (i=1; i<=g->nvertices; i++)
  {
    intree[i]=false;
    distan[i]=INFL;
    parent[i]=-1;
  }
  distan[start]=0;
  v = start;
  while (intree[v]==false)
  {
    intree[v]=true;
    for(i=0;i<g->degree[v];i++)
    {
      w=g->edges[v][i].v;
      weight=g->edges[v][i].weight;
      long tmp = distan[v]+weight;
      if (distan[w] > tmp && g->edges[v][i].weight<=g->edges[v][i].l)
      {
        if
        (
        (
         g->edges[v][i].t==0 && g->edges[v][i].a==0 && g->edges[v][i].l==0
        )
        ||
        (
          g->edges[v][i].a <= (distan[v] % g->edges[v][i].t)
          && (distan[v] % g->edges[v][i].t) <= (g->edges[v][i].a + g->edges[v][i].l)
          && g->edges[v][i].a <= (tmp % g->edges[v][i].t)
          && (tmp % g->edges[v][i].t) <= (g->edges[v][i].a + g->edges[v][i].l)
        )
        )
          distan[w]=tmp;
        else
        {
          if ((distan[v] % g->edges[v][i].t) < g->edges[v][i].a)
            dod = g->edges[v][i].a - (distan[v] % g->edges[v][i].t);
          else dod = g->edges[v][i].a + g->edges[v][i].t - (distan[v]% g->edges[v][i].t);
          distan [w] = tmp + dod;
        }
      }
    }
    v = 1;
    dist = INFL;
    for (i = 1; i<=g->nvertices; i++)
      if (intree[i]==false && dist > distan[i])
      {
        dist=distan[i];
        v=i;
      }
  }
}

int main ()
{
  int ntc;
  graph g;
  
  scanf ("%d", &ntc);
  for (int cntc=1; cntc<=ntc; cntc++)
  {
    read_graph (&g, true);
//    print_graph (&g);
    dijkstra (&g, 1);
    if (distan[g.nvertices]<INFL)
      printf ("%d\n", distan[g.nvertices]);
    else
      printf ("NIE\n");
  }
  return 0;
}
